chiark / gitweb /
bin/start-ssh-agent: Export `SSH_AUTH_SOCK' in just one place.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
119echo " all done."
120
121###--------------------------------------------------------------------------
122### Install global configuration.
123
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
132## Symlink the various dotfiles into place
133dotfiles="
134 bash_profile bash_logout bashrc inputrc bash_completion
135 emacs emacs-calc vm gnus.el ercrc.el
136 vimrc mg zile lesskey
137 parallel-config:.parallel/config
138 ipython_config.py:.ipython/profile_default/ipython_config.py
139 ditz-config
140 mailrc signature muttrc
141 cgrc tigrc
142 gdbinit
143 guile
144 rcrc
145 toprc
146 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
147 pulse-daemon.conf:.pulse/daemon.conf
148 aspell.conf
149 tclshrc:.tclshrc tclshrc:.wishrc
150 lisp-init.lisp:.cmucl-init.lisp
151 lisp-init.lisp:.sbclrc
152 lisp-init.lisp:.clisprc.lisp
153 lisp-init.lisp:.eclrc
154 swank.lisp
155 mdw-build.conf:.config/mdw-build.conf
156 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
157 dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
158[ "$xstuff" ] && dotfiles="$dotfiles
159 xinitrc xsession xmodmap vncrc vncsession
160 fonts.conf
161 stalonetrayrc
162 putty-defaults:.putty/sessions/Default%20Settings
163 mdw.session:.config/gnome-session/sessions/mdw.session
164 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
165 e-keybindings.cfg:.enlightenment/keybindings.cfg
166 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
167 e16-bindings:.e16/bindings.cfg"
168echo "Installing dotfiles..."
169for d in $dotfiles; do
170 target=.$d
171 case $d in
172 *:*) target=${d#*:} d=${d%%:*};;
173 esac
174 ft=$HOME$sub/$target
175 dir=${ft%/*}
176 mkdir -p $dir
177 ln -s $here/dot/$d $ft.new
178 mv $ft.new $ft
179 echo " $target"
180done
181echo " all done."
182
183## CPP-hack files which need it.
184cppfiles=""
185[ "$xstuff" ] && cppfiles="$cppfiles
186 Xdefaults"
187echo "Hacking files with C preprocessor..."
188defs="-DHOME=$HOME -DPROFILE=$here"
189defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
190for c in $cppfiles; do
191 target=.$c
192 case $c in
193 *:*) target=${c#*:} c=${c%%:*};;
194 esac
195 ft=$HOME$sub/$target
196 dir=${ft%/*}
197 mkdir -p $dir
198 cpp -P $defs dot/$c -o $ft.new
199 mv $ft.new $ft
200 echo " $target"
201done
202echo " all done."
203
204## Substitute things which need substituting.
205dotfilessubst="
206 gitconfig
207 mykermrc
208 pulse-default.pa.in:.pulse/default.pa"
209echo "Installing dotfiles with substitutions..."
210for d in $dotfilessubst; do
211 case $d in
212 *:*) target=${d#*:} d=${d%%:*};;
213 *) target=.$d d=$d.in;;
214 esac
215 ft=$HOME$sub/$target
216 dir=${ft%/*}
217 mkdir -p $dir
218 sed "
2191i\\
220### generated by $here/setup; do not edit!\\
221
222/@home@/ s\a\a$HOME\ag
223/@profile@/ s\a\a$here\ag
224/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
225" dot/$d >$ft.new
226 mv $ft.new $ft
227 echo " $target"
228done
229echo " all done."
230
231## Symlink backgrounds.
232backgrounds=$(cd bg && echo *)
233if [ "$xstuff" ]; then
234 echo "Installing backgrounds..."
235 for b in $backgrounds; do
236 for e in enlightenment e16; do
237 dir=$HOME$sub/.$e/backgrounds
238 t=$dir/$b
239 mkdir -p $dir
240 ln -s $here/bg/$b $t.new
241 mv $t.new $t
242 done
243 echo " $b"
244 done
245 echo " all done."
246fi
247
248###--------------------------------------------------------------------------
249### Install useful scripts included in this package.
250
251scripts="
252 mdw-editor
253 mdw-pager
254 mdw-conf
255 mdw-build mdw-sbuild mdw-sbuild-server
256 update-buildable-branch
257 emacsclient-hack
258 movemail-hack
259 sendmail-hack
260 aspell-hack
261 emerge-hack
262 lesspipe.sh
263 run-with-shell-env
264 start-ssh-agent
265 start-ssh-pageant
266 svnwrap
267 guest-console
268 hyperspec"
269[ "$xstuff" ] && scripts="$scripts
270 xinitcmd
271 un-backslashify-selection
272 lock-screen
273 xpra-start-xdummy
274 xshutdown"
275echo "Installing scripts..."
276mkdir -p $HOME$sub/bin
277for s in $scripts; do
278 ft=$HOME$sub/bin/$s
279 ln -s $here/bin/$s $ft.new
280 mv $ft.new $ft
281 echo " $s"
282done
283echo " all done."
284
285hacks="
286 ssh:ssh"
287echo "Installing hacks..."
288for h in $hacks; do
289 d=${h%%:*} h=${h#*:}
290 ft=$HOME$sub/bin/hacks/$d
291 mkdir -p $ft
292 ln -s $here/hacks/$h $ft/$h.new
293 mv $ft/$h.new $ft/$h
294 echo " $d:$h"
295done
296echo " all done."
297
298###--------------------------------------------------------------------------
299### Set up the Emacs config.
300
301$echon "Finding a suitable emacs:$echoc"
302emacs=no
303for i in emacs23 emacs24 emacs22 emacs21 emacs; do
304 if type -p >/dev/null $i; then
305 emacs=$i
306 break
307 fi
308done
309if [ $emacs = no ]; then
310 echo " failed."
311 emacs=:
312else
313 echo " $emacs."
314fi
315
316echo "Installing Emacs packages..."
317emacspkg="
318 make-regexp
319 ew-hols
320 mdw-gnus-patch
321 git git-blame vc-git stgit
322 mdw-multiple-cursors
323 quilt"
324for elib in $emacspkg; do
325 $echon " $elib:$echoc"
326 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
327 (progn
328 (setq load-path (nconc load-path (list "~/lib/emacs")))
329 (kill-emacs (condition-case nil
330 (progn (load-library "'"$elib"'") 0)
331 (error 1))))'; then
332 echo " already installed."
333 else
334 if [ -f el/$elib.el ]; then
335 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
336 else
337 $echon " downloading$echoc"
338 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
339 fi
340 $echon " compiling$echoc"
341 (cd $HOME$sub/lib/emacs;
342 $emacs >/dev/null 2>&1 --no-site-file --batch \
343 --eval '(byte-compile-file "'"$elib.el"'")')
344 echo " done."
345 fi
346done
347echo " all done."
348
349$echon "Setting up Emacs configuration:$echoc"
350$echon " linking$echoc"
351for f in dot-emacs.el Makefile; do
352 set -- $(echo $link | tr : ' ')
353 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
354 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
355done
356$echon " compiling$echoc"
357{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
358echo " done."
359
360###----- That's all, folks --------------------------------------------------